To get a table, use the find, findByName, or all method. For example:
If you want to change the table location or change the table size, you can use the move method to change the location, and the resize method to resize it. For example:
If you don't need the table, you can remove it using the remove method. For example:
window.onload = function () {
var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"));
initSpread(spread);
};
function initSpread(spread) {
spread.suspendPaint();
var spreadNS = GC.Spread.Sheets;
var sheet = spread.getSheet(0);
sheet.bind(spreadNS.Events.SelectionChanged, selectionChangedCallback);
var table = sheet.tables.add("table1", 1, 1, 4, 4, spreadNS.Tables.TableThemes.light1);
sheet.setColumnWidth(1, 120);
sheet.setColumnWidth(2, 120);
sheet.setColumnWidth(3, 120);
sheet.setColumnWidth(4, 120);
sheet.getCell(1, 1).text("First Name");
sheet.getCell(1, 2).text("Last Name");
sheet.getCell(1, 3).text("Score");
sheet.getCell(1, 4).text("Position");
sheet.getCell(2, 1).text("Alexa");
sheet.getCell(2, 2).text("Wilder");
sheet.getCell(2, 3).text("90");
sheet.getCell(2, 4).text("Web Developer");
sheet.getCell(3, 1).text("Victor");
sheet.getCell(3, 2).text("Wooten");
sheet.getCell(3, 3).text("70");
sheet.getCell(3, 4).text(".NET Developer");
sheet.getCell(4, 1).text("Ifeoma");
sheet.getCell(4, 2).text("Mays");
sheet.getCell(4, 3).text("85");
sheet.getCell(4, 4).text("Sales Manager");
spread.resumePaint();
function selectionChangedCallback() {
var sheet = spread.getActiveSheet();
var table = sheet.tables.find(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
if (table && table.name) {
_getElementById("removeTable").removeAttribute('disabled');
valueCheckCallback("moveRow", "moveColumn", "moveTable");
valueCheckCallback("resizeRow", "resizeColumn", "resizeTable");
} else {
_getElementById("removeTable").setAttribute('disabled', true);
_getElementById("moveTable").setAttribute('disabled', true);
_getElementById("resizeTable").setAttribute('disabled', true);
}
}
function valueCheckCallback(rowElementId, columnElementId, targetElementID) {
var rowInfo = parseInt(_getElementById("" + rowElementId).value);
var columnInfo = parseInt(_getElementById("" + columnElementId).value);
var targetElement = _getElementById("" + targetElementID);
if (isNaN(rowInfo) || isNaN(columnInfo)) {
targetElement.setAttribute('disabled', true);
} else {
targetElement.removeAttribute('disabled');
}
}
function removeTableFromOptionList(tableName) {
var removeNode = document.querySelector("option[value=" + tableName + "]");
if (removeNode) {
removeNode.parentNode.removeChild(removeNode);
}
}
//add table
_getElementById("addTable").addEventListener('click',function () {
var sheet = spread.getActiveSheet();
try {
var cr = sheet.getSelections()[0];
if (cr) {
cr = getActualRange(cr, sheet.getRowCount(), sheet.getColumnCount());
var tableName = getTableName(sheet);
sheet.tables.add(tableName, cr.row, cr.col, cr.rowCount, cr.colCount, spreadNS.Tables.TableThemes.light1);
}
} catch (ex) {
alert(!!ex.message ? ex.message : ex);
}
});
//remove table
_getElementById("removeTable").addEventListener('click',function () {
var sheet = spread.getActiveSheet();
try {
var table = sheet.tables.find(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
if (table) {
sheet.tables.remove(table);
removeTableFromOptionList(table.name());
}
} catch (ex) {
alert(!!ex.message ? ex.message : ex);
}
});
//move table
_getElementById("moveTable").addEventListener('click',function () {
var sheet = spread.getActiveSheet();
var table = sheet.tables.find(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
if (table) {
try {
var row = parseInt(_getElementById("moveRow").value);
var col = parseInt(_getElementById("moveColumn").value);
if (!isNaN(row) && !isNaN(col)) {
sheet.tables.move(table, row, col);
selectionChangedCallback();
}
} catch (ex) {
alert(!!ex.message ? ex.message : ex);
}
}
});
_getElementById("moveRow").addEventListener('keyup',function () {
valueCheckCallback("moveRow", "moveColumn", "moveTable");
});
_getElementById("moveColumn").addEventListener('keyup',function () {
valueCheckCallback("moveRow", "moveColumn", "moveTable");
});
//resize table
_getElementById("resizeTable").addEventListener('click',function () {
var sheet = spread.getActiveSheet();
var table = sheet.tables.find(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
if (table) {
try {
var row = parseInt(_getElementById("resizeRow").value);
var col = parseInt(_getElementById("resizeColumn").value);
if (!isNaN(row) && !isNaN(col)) {
sheet.tables.resize(table, row, col);
selectionChangedCallback();
}
} catch (ex) {
alert(!!ex.message ? ex.message : ex);
}
}
});
_getElementById("resizeRow").addEventListener('keyup',function () {
valueCheckCallback("resizeRow", "resizeColumn", "resizeTable");
});
_getElementById("resizeColumn").addEventListener('keyup',function () {
valueCheckCallback("resizeRow", "resizeColumn", "resizeTable");
});
function getTableName(sheet) {
var i = 0;
while (true) {
var name = "table" + i.toString();
if (!sheet.tables.findByName(name)) {
return name;
}
i++;
}
}
function getActualRange(range, maxRowCount, maxColCount) {
var row = range.row < 0 ? 0 : range.row;
var col = range.col < 0 ? 0 : range.col;
var rowCount = range.rowCount < 0 ? maxRowCount : range.rowCount;
var colCount = range.colCount < 0 ? maxColCount : range.colCount;
return new spreadNS.Range(row, col, rowCount, colCount);
}
}
function _getElementById(id){
return document.getElementById(id);
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div class="options-container">
<div class="option-group">
<label> Please select the table area.</label>
<label> tableName:</label>
<input id="tableName" />
</div>
<div class="option-group">
<input type="button" id="removeTable" value="Remove table" />
<input type="button" id="addTable" value="Add table" />
</div>
<hr>
<label>Move table to:</label>
<div class="option-group">
<label for="moveRow">Row:</label>
<input id="moveRow" />
</div>
<div class="option-group">
<label for="moveColumn">Column:</label>
<input id="moveColumn" />
</div>
<div class="option-group">
<input type="button" id="moveTable" value="Move table" />
</div>
<label>Resize table:</label>
<div class="option-group">
<label for="resizeRow">Row count:</label>
<input id="resizeRow" />
</div>
<div class="option-group">
<label for="resizeColumn">Column count:</label>
<input id="resizeColumn" />
</div>
<div class="option-group">
<input type="button" id="resizeTable" value="Resize table" />
</div>
</div>
</div></body>
</html>
.sample {
position: relative;
height: 100%;
overflow: auto;
}
.sample::after {
display: block;
content: "";
clear: both;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
.option-group {
margin-bottom: 6px;
}
label {
display: block;
margin-bottom: 6px;
}
input {
padding: 2px 4px;
width: 100%;
box-sizing: border-box;
}
input[type=button] {
margin-bottom: 6px;
}
hr {
border-color: #fff;
opacity: .2;
margin: 5px 0;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}

To get a table, use the find, findByName, or all method. For example:
If you want to change the table location or change the table size, you can use the move method to change the location, and the resize method to resize it. For example:
If you don't need the table, you can remove it using the remove method. For example:
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
const GCsheets = GC.Spread.Sheets;
function getTableName(sheet: GC.Spread.Sheets.Worksheet) {
let i = 0;
while (true) {
let name = "table" + i.toString();
if (!sheet.tables.findByName(name)) {
return name;
}
i++;
}
}
function getActualRange(range: GC.Spread.Sheets.Range, maxRowCount: number, maxColCount: number) {
let row = range.row < 0 ? 0 : range.row;
let col = range.col < 0 ? 0 : range.col;
let rowCount = range.rowCount < 0 ? maxRowCount : range.rowCount;
let colCount = range.colCount < 0 ? maxColCount : range.colCount;
return new GCsheets.Range(row, col, rowCount, colCount);
}
function valueCheckCallback (rowValue: any, columnValue: any) {
let rowInfo = parseInt(rowValue);
let columnInfo = parseInt(columnValue);
let targetElementDisableState = false;
if (isNaN(rowInfo) || isNaN(columnInfo) || rowInfo < 0 || columnInfo < 0) {
targetElementDisableState = true;
}
return targetElementDisableState;
}
function removeTableFromOptionList (tableName: string) {
let removeNode = document.querySelector("option[value=" + tableName + "]");
if (removeNode) {
removeNode.parentNode.removeChild(removeNode);
}
}
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
disabledRemoveTable = false;
disabledMoveTable = false;
disabledResizeTable = false;
moveRowValue: any = null;
moveColumnValue: any = null;
resizeRowValue: any = null;
resizeColumnValue: any = null;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
spread.suspendPaint();
let sheet = spread.getActiveSheet();
sheet.bind(GCsheets.Events.SelectionChanged, this.selectionChangedCallback.bind(this));
let table = sheet.tables.add("table1", 1, 1, 4, 4, GCsheets.Tables.TableThemes.light1);
sheet.setColumnWidth(1, 120);
sheet.setColumnWidth(2, 120);
sheet.setColumnWidth(3, 120);
sheet.setColumnWidth(4, 120);
sheet.getCell(1, 1).text("First Name");
sheet.getCell(1, 2).text("Last Name");
sheet.getCell(1, 3).text("Score");
sheet.getCell(1, 4).text("Position");
sheet.getCell(2, 1).text("Alexa");
sheet.getCell(2, 2).text("Wilder");
sheet.getCell(2, 3).text("90");
sheet.getCell(2, 4).text("Web Developer");
sheet.getCell(3, 1).text("Victor");
sheet.getCell(3, 2).text("Wooten");
sheet.getCell(3, 3).text("70");
sheet.getCell(3, 4).text(".NET Developer");
sheet.getCell(4, 1).text("Ifeoma");
sheet.getCell(4, 2).text("Mays");
sheet.getCell(4, 3).text("85");
sheet.getCell(4, 4).text("Sales Manager");
spread.resumePaint();
}
selectionChangedCallback () {
let spread = this.spread;
let sheet = spread.getActiveSheet();
let table = sheet.tables.find(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
if (table && table.name) {
this.disabledRemoveTable = false;
this.disabledMoveTable = valueCheckCallback(this.moveRowValue, this.moveColumnValue);
this.disabledResizeTable = valueCheckCallback(this.resizeRowValue, this.resizeColumnValue);
} else {
this.disabledRemoveTable = true;
this.disabledMoveTable = true;
this.disabledResizeTable = true;
}
}
onAddTableClickEvent (event: any) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
try {
let cr = sheet.getSelections()[0];
if (cr) {
cr = getActualRange(cr, sheet.getRowCount(), sheet.getColumnCount());
let tableName = getTableName(sheet);
sheet.tables.add(tableName, cr.row, cr.col, cr.rowCount, cr.colCount, GCsheets.Tables.TableThemes.light1);
}
} catch (ex) {
alert(!!ex.message ? ex.message : ex);
}
}
onRemoveTableClickEvent (event: any) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
try {
let table = sheet.tables.find(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
if (table) {
sheet.tables.remove(table);
removeTableFromOptionList(table.name());
}
} catch (ex) {
alert(!!ex.message ? ex.message : ex);
}
}
onMoveTableClickEvent (event: any) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
let table = sheet.tables.find(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
if (table) {
try {
let row = parseInt(this.moveRowValue);
let col = parseInt(this.moveColumnValue);
if (!isNaN(row) && !isNaN(col)) {
sheet.tables.move(table, row, col);
this.selectionChangedCallback();
}
} catch (ex) {
alert(!!ex.message ? ex.message : ex);
}
}
}
onMoveRowKeyUpEvent (event: any) {
this.moveRowValue = event.target.value;
this.disabledMoveTable = valueCheckCallback(this.moveRowValue, this.moveColumnValue);
}
onMoveColumnKeyUpEvent (event: any) {
this.moveColumnValue = event.target.value;
this.disabledMoveTable = valueCheckCallback(this.moveRowValue, this.moveColumnValue);
}
onResizeTableClickEvent (event: any) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
let table = sheet.tables.find(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
if (table) {
try {
let row = parseInt(this.resizeRowValue);
let col = parseInt(this.resizeColumnValue);
if (!isNaN(row) && !isNaN(col)) {
sheet.tables.resize(table, row, col);
this.selectionChangedCallback();
}
} catch (ex) {
alert(!!ex.message ? ex.message : ex);
}
}
}
onResizeRowKeyUpEvent (event: any) {
this.resizeRowValue = event.target.value;
this.disabledResizeTable = valueCheckCallback(this.resizeRowValue, this.resizeColumnValue);
}
onResizeColumnKeyUpEvent (event: any) {
this.resizeColumnValue = event.target.value;
this.disabledResizeTable = valueCheckCallback(this.resizeRowValue, this.resizeColumnValue);
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
<div class="options-container">
<div class="option-group">
<label> Please select the table area.</label>
<label> tableName:</label>
<input id="tableName" />
</div>
<div class="option-group">
<input type="button" id="removeTable" value="Remove table" [disabled]="disabledRemoveTable" (click)="onRemoveTableClickEvent()" />
<input type="button" id="addTable" value="Add table" (click)="onAddTableClickEvent()" />
</div>
<hr>
<label>Move table to:</label>
<div class="option-group">
<label for="moveRow">Row:</label>
<input id="moveRow" [value]="moveRowValue" (keyup)="onMoveRowKeyUpEvent($event)" />
</div>
<div class="option-group">
<label for="moveColumn">Column:</label>
<input id="moveColumn" [value]="moveColumnValue" (keyup)="onMoveColumnKeyUpEvent($event)" />
</div>
<div class="option-group">
<input type="button" id="moveTable" value="Move table" [disabled]="disabledMoveTable" (click)="onMoveTableClickEvent()" />
</div>
<label>Resize table:</label>
<div class="option-group">
<label for="resizeRow">Row count:</label>
<input id="resizeRow" [value]="resizeRowValue" (keyup)="onResizeRowKeyUpEvent($event)" />
</div>
<div class="option-group">
<label for="resizeColumn">Column count:</label>
<input id="resizeColumn" [value]="resizeColumnValue" (keyup)="onResizeColumnKeyUpEvent($event)" />
</div>
<div class="option-group">
<input type="button" id="resizeTable" value="Resize table" [disabled]="disabledResizeTable" (click)="onResizeTableClickEvent()" />
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
.option-group {
margin-bottom: 6px;
}
label {
display: block;
margin-bottom: 6px;
}
input {
padding: 2px 4px;
width: 100%;
box-sizing: border-box;
}
input[type=button] {
margin-bottom: 6px;
}
hr {
border-color: #fff;
opacity: .2;
margin: 5px 0;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

To get a table, use the find, findByName, or all method. For example:
If you want to change the table location or change the table size, you can use the move method to change the location, and the resize method to resize it. For example:
If you don't need the table, you can remove it using the remove method. For example:
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
</gc-spread-sheets>
<div class="options-container">
<div class="option-group">
<label> Please select the table area.</label>
<label> tableName:</label>
<input id="tableName" />
</div>
<div class="option-group">
<input type="button" id="removeTable" value="Remove table" :disabled="disabledRemoveTable" v-on:click="onRemoveTableClickEvent" />
<input type="button" id="addTable" value="Add table" v-on:click="onAddTableClickEvent" />
</div>
<hr>
<label>Move table to:</label>
<div class="option-group">
<label for="moveRow">Row:</label>
<input id="moveRow" v-model.number="moveRowValue" v-on:keyup="onMoveRowColumnKeyUpEvent" />
</div>
<div class="option-group">
<label for="moveColumn">Column:</label>
<input id="moveColumn" v-model.number="moveColumnValue" v-on:keyup="onMoveRowColumnKeyUpEvent" />
</div>
<div class="option-group">
<input type="button" id="moveTable" value="Move table" :disabled="disabledMoveTable" v-on:click="onMoveTableClickEvent" />
</div>
<label>Resize table:</label>
<div class="option-group">
<label for="resizeRow">Row count:</label>
<input id="resizeRow" v-model.number="resizeRowValue" v-on:keyup="onResizeRowColumnKeyUpEvent" />
</div>
<div class="option-group">
<label for="resizeColumn">Column count:</label>
<input id="resizeColumn" v-model.number="resizeColumnValue" v-on:keyup="onResizeRowColumnKeyUpEvent" />
</div>
<div class="option-group">
<input type="button" id="resizeTable" value="Resize table" :disabled="disabledResizeTable" v-on:click="onResizeTableClickEvent" />
</div>
</div>
</div>
</template>
<script>
import Vue from 'vue';
import '@mescius/spread-sheets-vue'
import GC from '@mescius/spread-sheets';
import './styles.css';
const GCsheets = GC.Spread.Sheets;
function getTableName(sheet) {
let i = 0;
while (true) {
let name = "table" + i.toString();
if (!sheet.tables.findByName(name)) {
return name;
}
i++;
}
}
function getActualRange(range, maxRowCount, maxColCount) {
let row = range.row < 0 ? 0 : range.row;
let col = range.col < 0 ? 0 : range.col;
let rowCount = range.rowCount < 0 ? maxRowCount : range.rowCount;
let colCount = range.colCount < 0 ? maxColCount : range.colCount;
return new GCsheets.Range(row, col, rowCount, colCount);
}
function getValueCheckValue (rowValue, columnValue) {
let rowInfo = parseInt(rowValue);
let columnInfo = parseInt(columnValue);
let targetElementDisableState = false;
if (isNaN(rowInfo) || isNaN(columnInfo) || rowInfo < 0 || columnInfo < 0) {
targetElementDisableState = true;
}
return targetElementDisableState;
}
function removeTableFromOptionList (tableName) {
let removeNode = document.querySelector("option[value=" + tableName + "]");
if (removeNode) {
removeNode.parentNode.removeChild(removeNode);
}
}
let App = Vue.extend({
name: "app",
data: function() {
return {
spread: null,
disabledRemoveTable: false,
disabledMoveTable: false,
disabledResizeTable: false,
moveRowValue: null,
moveColumnValue: null,
resizeRowValue: null,
resizeColumnValue: null
};
},
methods:{
initSpread: function (spread) {
this.spread = spread;
spread.suspendPaint();
let sheet = spread.getActiveSheet();
sheet.bind(GCsheets.Events.SelectionChanged, this.selectionChangedCallback.bind(this));
let table = sheet.tables.add("table1", 1, 1, 4, 4, GCsheets.Tables.TableThemes.light1);
sheet.setColumnWidth(1, 120);
sheet.setColumnWidth(2, 120);
sheet.setColumnWidth(3, 120);
sheet.setColumnWidth(4, 120);
sheet.getCell(1, 1).text("First Name");
sheet.getCell(1, 2).text("Last Name");
sheet.getCell(1, 3).text("Score");
sheet.getCell(1, 4).text("Position");
sheet.getCell(2, 1).text("Alexa");
sheet.getCell(2, 2).text("Wilder");
sheet.getCell(2, 3).text("90");
sheet.getCell(2, 4).text("Web Developer");
sheet.getCell(3, 1).text("Victor");
sheet.getCell(3, 2).text("Wooten");
sheet.getCell(3, 3).text("70");
sheet.getCell(3, 4).text(".NET Developer");
sheet.getCell(4, 1).text("Ifeoma");
sheet.getCell(4, 2).text("Mays");
sheet.getCell(4, 3).text("85");
sheet.getCell(4, 4).text("Sales Manager");
spread.resumePaint();
},
selectionChangedCallback: function () {
let spread = this.spread;
let sheet = spread.getActiveSheet();
let table = sheet.tables.find(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
if (table && table.name) {
this.disabledRemoveTable = false;
this.disabledMoveTable = getValueCheckValue(this.moveRowValue, this.moveColumnValue);
this.disabledResizeTable = getValueCheckValue(this.resizeRowValue, this.resizeColumnValue);
} else {
this.disabledRemoveTable = true;
this.disabledMoveTable = true;
this.disabledResizeTable = true;
}
},
onAddTableClickEvent: function (e) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
try {
let cr = sheet.getSelections()[0];
if (cr) {
cr = getActualRange(cr, sheet.getRowCount(), sheet.getColumnCount());
let tableName = getTableName(sheet);
sheet.tables.add(tableName, cr.row, cr.col, cr.rowCount, cr.colCount, GCsheets.Tables.TableThemes.light1);
}
} catch (ex) {
alert(!!ex.message ? ex.message : ex);
}
},
onRemoveTableClickEvent: function (e) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
try {
let table = sheet.tables.find(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
if (table) {
sheet.tables.remove(table);
removeTableFromOptionList(table.name());
}
} catch (ex) {
alert(!!ex.message ? ex.message : ex);
}
},
onMoveTableClickEvent: function (e) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
let table = sheet.tables.find(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
if (table) {
try {
let row = parseInt(this.moveRowValue);
let col = parseInt(this.moveColumnValue);
if (!isNaN(row) && !isNaN(col)) {
sheet.tables.move(table, row, col);
this.selectionChangedCallback();
}
} catch (ex) {
alert(!!ex.message ? ex.message : ex);
}
}
},
onMoveRowColumnKeyUpEvent: function (e) {
this.disabledMoveTable = getValueCheckValue(this.moveRowValue, this.moveColumnValue);
},
onResizeTableClickEvent: function (e) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
let table = sheet.tables.find(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
if (table) {
try {
let row = parseInt(this.resizeRowValue);
let col = parseInt(this.resizeColumnValue);
if (!isNaN(row) && !isNaN(col)) {
sheet.tables.resize(table, row, col);
this.selectionChangedCallback();
}
} catch (ex) {
alert(!!ex.message ? ex.message : ex);
}
}
},
onResizeRowColumnKeyUpEvent: function (e) {
this.disabledResizeTable = getValueCheckValue(this.resizeRowValue, this.resizeColumnValue);
}
}
});
new Vue({ render: h => h(App) }).$mount('#app');
</script>
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/vue/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.vue');
System.import('$DEMOROOT$/en/lib/vue/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample {
position: relative;
height: 100%;
overflow: auto;
}
.sample::after {
display: block;
content: "";
clear: both;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
.option-group {
margin-bottom: 6px;
}
label {
display: block;
margin-bottom: 6px;
}
input {
padding: 2px 4px;
width: 100%;
box-sizing: border-box;
}
input[type=button] {
margin-bottom: 6px;
}
hr {
border-color: #fff;
opacity: .2;
margin: 5px 0;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: 'vue-loader' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.min.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
}
}
});
})(this);

To get a table, use the find, findByName, or all method. For example:
If you want to change the table location or change the table size, you can use the move method to change the location, and the resize method to resize it. For example:
If you don't need the table, you can remove it using the remove method. For example:
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
// import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets } from '@mescius/spread-sheets-react';
const GCsheets = GC.Spread.Sheets;
function getTableName(sheet) {
let i = 0;
while (true) {
let name = "table" + i.toString();
if (!sheet.tables.findByName(name)) {
return name;
}
i++;
}
}
function getActualRange(range, maxRowCount, maxColCount) {
let row = range.row < 0 ? 0 : range.row;
let col = range.col < 0 ? 0 : range.col;
let rowCount = range.rowCount < 0 ? maxRowCount : range.rowCount;
let colCount = range.colCount < 0 ? maxColCount : range.colCount;
return new GCsheets.Range(row, col, rowCount, colCount);
}
function getValueCheckValue(rowValue, columnValue) {
let rowInfo = parseInt(rowValue);
let columnInfo = parseInt(columnValue);
let targetElementDisableState = false;
if (isNaN(rowInfo) || isNaN(columnInfo) || rowInfo < 0 || columnInfo < 0) {
targetElementDisableState = true;
}
return targetElementDisableState;
}
function removeTableFromOptionList(tableName) {
let removeNode = document.querySelector("option[value=" + tableName + "]");
if (removeNode) {
removeNode.parentNode.removeChild(removeNode);
}
}
let spread = null;
export function AppFunc() {
const [customOption, setCustomOption] = React.useState({
disabledRemoveTable: false,
disabledMoveTable: false,
disabledResizeTable: false,
moveRowValue: null,
moveColumnValue: null,
resizeRowValue: null,
resizeColumnValue: null
});
const initSpread = (currSpread) => {
spread = currSpread;
spread.suspendPaint();
let sheet = spread.getActiveSheet();
sheet.bind(GCsheets.Events.SelectionChanged, selectionChangedCallback);
let table = sheet.tables.add("table1", 1, 1, 4, 4, GCsheets.Tables.TableThemes.light1);
sheet.setColumnWidth(1, 120);
sheet.setColumnWidth(2, 120);
sheet.setColumnWidth(3, 120);
sheet.setColumnWidth(4, 120);
sheet.getCell(1, 1).text("First Name");
sheet.getCell(1, 2).text("Last Name");
sheet.getCell(1, 3).text("Score");
sheet.getCell(1, 4).text("Position");
sheet.getCell(2, 1).text("Alexa");
sheet.getCell(2, 2).text("Wilder");
sheet.getCell(2, 3).text("90");
sheet.getCell(2, 4).text("Web Developer");
sheet.getCell(3, 1).text("Victor");
sheet.getCell(3, 2).text("Wooten");
sheet.getCell(3, 3).text("70");
sheet.getCell(3, 4).text(".NET Developer");
sheet.getCell(4, 1).text("Ifeoma");
sheet.getCell(4, 2).text("Mays");
sheet.getCell(4, 3).text("85");
sheet.getCell(4, 4).text("Sales Manager");
spread.resumePaint();
}
const selectionChangedCallback = () => {
let sheet = spread.getActiveSheet();
let table = sheet.tables.find(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
if (table && table.name) {
setCustomOption({
...customOption,
disabledRemoveTable: false,
disabledMoveTable: getValueCheckValue(customOption.moveRowValue, customOption.moveColumnValue),
disabledResizeTable: getValueCheckValue(customOption.resizeRowValue, customOption.resizeColumnValue)
});
} else {
setCustomOption({ ...customOption, disabledRemoveTable: true, disabledMoveTable: true, disabledResizeTable: true });
}
}
const onAddTableClickEvent = (e) => {
let sheet = spread.getActiveSheet();
try {
let cr = sheet.getSelections()[0];
if (cr) {
cr = getActualRange(cr, sheet.getRowCount(), sheet.getColumnCount());
let tableName = getTableName(sheet);
sheet.tables.add(tableName, cr.row, cr.col, cr.rowCount, cr.colCount, GCsheets.Tables.TableThemes.light1);
}
} catch (ex) {
alert(!!ex.message ? ex.message : ex);
}
}
const onRemoveTableClickEvent = (e) => {
let sheet = spread.getActiveSheet();
try {
let table = sheet.tables.find(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
if (table) {
sheet.tables.remove(table);
removeTableFromOptionList(table.name());
}
} catch (ex) {
alert(!!ex.message ? ex.message : ex);
}
}
const onMoveTableClickEvent = (e) => {
let sheet = spread.getActiveSheet();
let table = sheet.tables.find(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
if (table) {
try {
let row = parseInt(customOption.moveRowValue);
let col = parseInt(customOption.moveColumnValue);
if (!isNaN(row) && !isNaN(col)) {
sheet.tables.move(table, row, col);
selectionChangedCallback();
}
} catch (ex) {
alert(!!ex.message ? ex.message : ex);
}
}
}
const onMoveRowColumnKeyUpEvent = (e) => {
setCustomOption({ ...customOption, disabledMoveTable: getValueCheckValue(customOption.moveRowValue, customOption.moveColumnValue) });
}
const onResizeTableClickEvent = (e) => {
let sheet = spread.getActiveSheet();
let table = sheet.tables.find(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
if (table) {
try {
let row = parseInt(customOption.resizeRowValue);
let col = parseInt(customOption.resizeColumnValue);
if (!isNaN(row) && !isNaN(col)) {
sheet.tables.resize(table, row, col);
selectionChangedCallback();
}
} catch (ex) {
alert(!!ex.message ? ex.message : ex);
}
}
}
const onResizeRowColumnKeyUpEvent = (e) => {
setCustomOption({ ...customOption, disabledResizeTable: getValueCheckValue(customOption.resizeRowValue, customOption.resizeColumnValue) });
}
const handleMoveRowChange = (e) => {
setCustomOption({ ...customOption, moveRowValue: e.target.value });
}
const handleMoveColumnChange = (e) => {
setCustomOption({ ...customOption, moveColumnValue: e.target.value });
}
const handleResizeRowChange = (e) => {
setCustomOption({ ...customOption, resizeRowValue: e.target.value });
}
const handleResizeColumnChange = (e) => {
setCustomOption({ ...customOption, resizeColumnValue: e.target.value });
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
</SpreadSheets>
</div>
<Panel
disabledRemoveTable={customOption.disabledRemoveTable}
disabledMoveTable={customOption.disabledMoveTable}
disabledResizeTable={customOption.disabledResizeTable}
moveRowValue={customOption.moveRowValue}
moveColumnValue={customOption.moveColumnValue}
resizeRowValue={customOption.resizeRowValue}
resizeColumnValue={customOption.resizeColumnValue}
handleMoveRowChange={handleMoveRowChange}
handleMoveColumnChange={handleMoveColumnChange}
handleResizeRowChange={handleResizeRowChange}
handleResizeColumnChange={handleResizeColumnChange}
onAddTableClickEvent={(e) => { onAddTableClickEvent(e) }}
onRemoveTableClickEvent={(e) => { onRemoveTableClickEvent(e) }}
onMoveTableClickEvent={(e) => { onMoveTableClickEvent(e) }}
onMoveRowColumnKeyUpEvent={(e) => { onMoveRowColumnKeyUpEvent(e) }}
onResizeTableClickEvent={(e) => { onResizeTableClickEvent(e) }}
onResizeRowColumnKeyUpEvent={(e) => { onResizeRowColumnKeyUpEvent(e) }}
/>
</div>
);
}
function Panel(props) {
return (
<div class="options-container">
<div class="option-group">
<label> Please select the table area.</label>
<label> tableName:</label>
<input id="tableName" />
</div>
<div class="option-group">
<input type="button" id="removeTable" value="Remove table" disabled={props.disabledRemoveTable} onClick={(e) => { props.onRemoveTableClickEvent(e) }} />
<input type="button" id="addTable" value="Add table" onClick={(e) => { props.onAddTableClickEvent(e) }} />
</div>
<hr></hr>
<label>Move table to:</label>
<div class="option-group">
<label for="moveRow">Row:</label>
<input id="moveRow" value={props.moveRowValue} onChange={props.handleMoveRowChange} onKeyUp={(e) => { props.onMoveRowColumnKeyUpEvent(e) }} />
</div>
<div class="option-group">
<label for="moveColumn">Column:</label>
<input id="moveColumn" value={props.moveColumnValue} onChange={props.handleMoveColumnChange} onKeyUp={(e) => { props.onMoveRowColumnKeyUpEvent(e) }} />
</div>
<div class="option-group">
<input type="button" id="moveTable" value="Move table" disabled={props.disabledMoveTable} onClick={(e) => { props.onMoveTableClickEvent(e) }} />
</div>
<label>Resize table:</label>
<div class="option-group">
<label for="resizeRow">Row count:</label>
<input id="resizeRow" value={props.resizeRowValue} onChange={props.handleResizeRowChange} onKeyUp={(e) => { props.onResizeRowColumnKeyUpEvent(e) }} />
</div>
<div class="option-group">
<label for="resizeColumn">Column count:</label>
<input id="resizeColumn" value={props.resizeColumnValue} onChange={props.handleResizeColumnChange} onKeyUp={(e) => { props.onResizeRowColumnKeyUpEvent(e) }} />
</div>
<div class="option-group">
<input type="button" id="resizeTable" value="Resize table" disabled={props.disabledResizeTable} onClick={(e) => { props.onResizeTableClickEvent(e) }} />
</div>
</div>
);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets } from '@mescius/spread-sheets-react';
const Component = React.Component;
const GCsheets = GC.Spread.Sheets;
function getTableName(sheet) {
let i = 0;
while (true) {
let name = "table" + i.toString();
if (!sheet.tables.findByName(name)) {
return name;
}
i++;
}
}
function getActualRange(range, maxRowCount, maxColCount) {
let row = range.row < 0 ? 0 : range.row;
let col = range.col < 0 ? 0 : range.col;
let rowCount = range.rowCount < 0 ? maxRowCount : range.rowCount;
let colCount = range.colCount < 0 ? maxColCount : range.colCount;
return new GCsheets.Range(row, col, rowCount, colCount);
}
function getValueCheckValue(rowValue, columnValue) {
let rowInfo = parseInt(rowValue);
let columnInfo = parseInt(columnValue);
let targetElementDisableState = false;
if (isNaN(rowInfo) || isNaN(columnInfo) || rowInfo < 0 || columnInfo < 0) {
targetElementDisableState = true;
}
return targetElementDisableState;
}
function removeTableFromOptionList(tableName) {
let removeNode = document.querySelector("option[value=" + tableName + "]");
if (removeNode) {
removeNode.parentNode.removeChild(removeNode);
}
}
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.state = {
disabledRemoveTable: false,
disabledMoveTable: false,
disabledResizeTable: false,
moveRowValue: null,
moveColumnValue: null,
resizeRowValue: null,
resizeColumnValue: null
};
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
</SpreadSheets>
</div>
<Panel
disabledRemoveTable={this.state.disabledRemoveTable}
disabledMoveTable={this.state.disabledMoveTable}
disabledResizeTable={this.state.disabledResizeTable}
moveRowValue={this.state.moveRowValue}
moveColumnValue={this.state.moveColumnValue}
resizeRowValue={this.state.resizeRowValue}
resizeColumnValue={this.state.resizeColumnValue}
handleMoveRowChange={this.handleMoveRowChange.bind(this)}
handleMoveColumnChange={this.handleMoveColumnChange.bind(this)}
handleResizeRowChange={this.handleResizeRowChange.bind(this)}
handleResizeColumnChange={this.handleResizeColumnChange.bind(this)}
onAddTableClickEvent={(e) => { this.onAddTableClickEvent(e) }}
onRemoveTableClickEvent={(e) => { this.onRemoveTableClickEvent(e) }}
onMoveTableClickEvent={(e) => { this.onMoveTableClickEvent(e) }}
onMoveRowColumnKeyUpEvent={(e) => { this.onMoveRowColumnKeyUpEvent(e) }}
onResizeTableClickEvent={(e) => { this.onResizeTableClickEvent(e) }}
onResizeRowColumnKeyUpEvent={(e) => { this.onResizeRowColumnKeyUpEvent(e) }}
/>
</div>
);
}
initSpread(spread) {
this.spread = spread;
spread.suspendPaint();
let sheet = spread.getActiveSheet();
sheet.bind(GCsheets.Events.SelectionChanged, this.selectionChangedCallback.bind(this));
let table = sheet.tables.add("table1", 1, 1, 4, 4, GCsheets.Tables.TableThemes.light1);
sheet.setColumnWidth(1, 120);
sheet.setColumnWidth(2, 120);
sheet.setColumnWidth(3, 120);
sheet.setColumnWidth(4, 120);
sheet.getCell(1, 1).text("First Name");
sheet.getCell(1, 2).text("Last Name");
sheet.getCell(1, 3).text("Score");
sheet.getCell(1, 4).text("Position");
sheet.getCell(2, 1).text("Alexa");
sheet.getCell(2, 2).text("Wilder");
sheet.getCell(2, 3).text("90");
sheet.getCell(2, 4).text("Web Developer");
sheet.getCell(3, 1).text("Victor");
sheet.getCell(3, 2).text("Wooten");
sheet.getCell(3, 3).text("70");
sheet.getCell(3, 4).text(".NET Developer");
sheet.getCell(4, 1).text("Ifeoma");
sheet.getCell(4, 2).text("Mays");
sheet.getCell(4, 3).text("85");
sheet.getCell(4, 4).text("Sales Manager");
spread.resumePaint();
}
selectionChangedCallback() {
let spread = this.spread;
let sheet = spread.getActiveSheet();
let table = sheet.tables.find(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
if (table && table.name) {
this.setState({
disabledRemoveTable: false,
disabledMoveTable: getValueCheckValue(this.state.moveRowValue, this.state.moveColumnValue),
disabledResizeTable: getValueCheckValue(this.state.resizeRowValue, this.state.resizeColumnValue)
});
} else {
this.setState({ disabledRemoveTable: true, disabledMoveTable: true, disabledResizeTable: true });
}
}
onAddTableClickEvent(e) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
try {
let cr = sheet.getSelections()[0];
if (cr) {
cr = getActualRange(cr, sheet.getRowCount(), sheet.getColumnCount());
let tableName = getTableName(sheet);
sheet.tables.add(tableName, cr.row, cr.col, cr.rowCount, cr.colCount, GCsheets.Tables.TableThemes.light1);
}
} catch (ex) {
alert(!!ex.message ? ex.message : ex);
}
}
onRemoveTableClickEvent(e) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
try {
let table = sheet.tables.find(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
if (table) {
sheet.tables.remove(table);
removeTableFromOptionList(table.name());
}
} catch (ex) {
alert(!!ex.message ? ex.message : ex);
}
}
onMoveTableClickEvent(e) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
let table = sheet.tables.find(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
if (table) {
try {
let row = parseInt(this.state.moveRowValue);
let col = parseInt(this.state.moveColumnValue);
if (!isNaN(row) && !isNaN(col)) {
sheet.tables.move(table, row, col);
this.selectionChangedCallback();
}
} catch (ex) {
alert(!!ex.message ? ex.message : ex);
}
}
}
onMoveRowColumnKeyUpEvent(e) {
this.setState({ disabledMoveTable: getValueCheckValue(this.state.moveRowValue, this.state.moveColumnValue) });
}
onResizeTableClickEvent(e) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
let table = sheet.tables.find(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
if (table) {
try {
let row = parseInt(this.state.resizeRowValue);
let col = parseInt(this.state.resizeColumnValue);
if (!isNaN(row) && !isNaN(col)) {
sheet.tables.resize(table, row, col);
this.selectionChangedCallback();
}
} catch (ex) {
alert(!!ex.message ? ex.message : ex);
}
}
}
onResizeRowColumnKeyUpEvent(e) {
this.setState({ disabledResizeTable: getValueCheckValue(this.state.resizeRowValue, this.state.resizeColumnValue) });
}
handleMoveRowChange(e) {
this.setState({ moveRowValue: e.target.value });
}
handleMoveColumnChange(e) {
this.setState({ moveColumnValue: e.target.value });
}
handleResizeRowChange(e) {
this.setState({ resizeRowValue: e.target.value });
}
handleResizeColumnChange(e) {
this.setState({ resizeColumnValue: e.target.value });
}
}
class Panel extends Component {
constructor(props) {
super(props);
}
render() {
return (
<div class="options-container">
<div class="option-group">
<label> Please select the table area.</label>
<label> tableName:</label>
<input id="tableName" />
</div>
<div class="option-group">
<input type="button" id="removeTable" value="Remove table" disabled={this.props.disabledRemoveTable} onClick={(e) => { this.props.onRemoveTableClickEvent(e) }} />
<input type="button" id="addTable" value="Add table" onClick={(e) => { this.props.onAddTableClickEvent(e) }} />
</div>
<hr></hr>
<label>Move table to:</label>
<div class="option-group">
<label for="moveRow">Row:</label>
<input id="moveRow" value={this.props.moveRowValue} onChange={this.props.handleMoveRowChange} onKeyUp={(e) => { this.props.onMoveRowColumnKeyUpEvent(e) }} />
</div>
<div class="option-group">
<label for="moveColumn">Column:</label>
<input id="moveColumn" value={this.props.moveColumnValue} onChange={this.props.handleMoveColumnChange} onKeyUp={(e) => { this.props.onMoveRowColumnKeyUpEvent(e) }} />
</div>
<div class="option-group">
<input type="button" id="moveTable" value="Move table" disabled={this.props.disabledMoveTable} onClick={(e) => { this.props.onMoveTableClickEvent(e) }} />
</div>
<label>Resize table:</label>
<div class="option-group">
<label for="resizeRow">Row count:</label>
<input id="resizeRow" value={this.props.resizeRowValue} onChange={this.props.handleResizeRowChange} onKeyUp={(e) => { this.props.onResizeRowColumnKeyUpEvent(e) }} />
</div>
<div class="option-group">
<label for="resizeColumn">Column count:</label>
<input id="resizeColumn" value={this.props.resizeColumnValue} onChange={this.props.handleResizeColumnChange} onKeyUp={(e) => { this.props.onResizeRowColumnKeyUpEvent(e) }} />
</div>
<div class="option-group">
<input type="button" id="resizeTable" value="Resize table" disabled={this.props.disabledResizeTable} onClick={(e) => { this.props.onResizeTableClickEvent(e) }} />
</div>
</div>
)
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample {
position: relative;
height: 100%;
overflow: auto;
}
.sample::after {
display: block;
content: "";
clear: both;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
.option-group {
margin-bottom: 6px;
}
label {
display: block;
margin-bottom: 6px;
}
input {
padding: 2px 4px;
width: 100%;
box-sizing: border-box;
}
input[type=button] {
margin-bottom: 6px;
}
hr {
border-color: #fff;
opacity: .2;
margin: 5px 0;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);